#pragma semicolon 1
#pragma newdecls required
#include <sdktools_functions>
#include <sdkhooks>
#include <vip_core>
#include <clientprefs>

public Plugin myinfo =
{
	name = "[VIP] COIN",
	author = "Pheonix (˙·٠●Феникс●٠·˙) & R1KO, pracc",
	version = "2.0.3",
	url = "https://ezgh.ru, https://e-players.ru"
};

static const char g_sFeature[] = "COIN";

int m_nActiveCoinRank;
int g_iClientCoin[MAXPLAYERS+1];
char g_szClientCategory[MAXPLAYERS+1][256];
Handle g_hCookie;
KeyValues g_hKeyValues;

public void OnPluginStart()
{
	g_hCookie = RegClientCookie(g_sFeature, g_sFeature, CookieAccess_Protected);

	m_nActiveCoinRank = FindSendPropInfo("CCSPlayerResource", "m_nActiveCoinRank");
	if (m_nActiveCoinRank == -1)
	{
		SetFailState("Fatal Error: Unable to find offset: \"CCSPlayerResource::m_nActiveCoinRank\"");
	}

	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
	
	RegConsoleCmd("sm_coin", Command_Coin);
	RegConsoleCmd("sm_coins", Command_Coin);
	
	LoadTranslations("vip_core.phrases");
	LoadTranslations("vip_coin.phrases");
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, BOOL, SELECTABLE, OnItemSelect);
}

public void OnPluginEnd() 
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature);
	}
}

public void OnMapStart()
{
	SDKHook(FindEntityByClassname(MaxClients+1, "cs_player_manager"), SDKHook_ThinkPost, Hook_OnThinkPost);
	
	if (g_hKeyValues)
	{
		g_hKeyValues.Close();
	}

	g_hKeyValues = new KeyValues(g_sFeature);
	char szBuffer[128], szLanguageCode[4], szLanguage[16];
	GetLanguageInfo(GetServerLanguage(), szLanguageCode, sizeof(szLanguageCode), szLanguage, sizeof(szLanguage));
	BuildPath(Path_SM, szBuffer, sizeof(szBuffer), "data/vip/modules/coin/%s.ini", szLanguage);
	if(!g_hKeyValues.ImportFromFile(szBuffer))
	{
		SetFailState("[COIN] - Файл конфигураций (%s) не найден", szBuffer);
	}
}

public Action Command_Coin(int client, int args)
{
	if (!client)
	{
		return Plugin_Handled;
	}
	
	if(VIP_IsClientVIP(client) && VIP_IsClientFeatureUse(client, g_sFeature))
	{
		DisplayCategoriesMenu(client);
	}
	else
	{
		VIP_PrintToChatClient(client, "%t", "COMMAND_NO_ACCESS");
	}
	
	return Plugin_Handled;
}

void DisplayCategoriesMenu(int iClient)
{
	Menu hMenu = new Menu(MenuHandler_Category);
	hMenu.ExitBackButton = true;
	hMenu.SetTitle("%t:\n ", "Title");

	if (!g_szClientCategory[iClient][0])
	{
		char szItem[32];
		FormatEx(szItem, sizeof(szItem), "%t\n ", "Default");
		hMenu.AddItem("0", szItem);
	}

	g_hKeyValues.Rewind();

	if (g_szClientCategory[iClient][0] && !g_hKeyValues.JumpToKey(g_szClientCategory[iClient]))
	{
		VIP_PrintToChatClient(iClient, "%t!", "Error");
		return;
	}

	if(g_hKeyValues.GotoFirstSubKey())
	{
		char szCategory[64];
		do
		{
			g_hKeyValues.GetSectionName(szCategory, sizeof(szCategory));
			hMenu.AddItem(szCategory, szCategory);
		}
		while (g_hKeyValues.GotoNextKey());
	}

	hMenu.Display(iClient, MENU_TIME_FOREVER);
}

public int MenuHandler_Category(Menu hMenu, MenuAction action, int iClient, int iItem)
{
	switch(action)
	{
		case MenuAction_End:
		{
			hMenu.Close();
		}
		case MenuAction_Cancel:
		{
			if(iItem == MenuCancel_ExitBack)
			{
				if (g_szClientCategory[iClient][0])
				{
					RemoveLastClientStackCategory(iClient);
					DisplayCategoriesMenu(iClient);
					return 0;
				}
				VIP_SendClientVIPMenu(iClient);
			}
		}
		case MenuAction_Select:
		{
			char szCategory[64];
			hMenu.GetItem(iItem, szCategory, sizeof(szCategory));
			if (!strcmp(szCategory, "0"))
			{
				g_iClientCoin[iClient] = 0;
				SetClientCookie(iClient, g_hCookie, szCategory);
				DisplayCategoriesMenu(iClient);
				VIP_PrintToChatClient(iClient, " \x04%t!", "Coin Off");
				return 0;
			}

			g_hKeyValues.JumpToKey(g_szClientCategory[iClient]);
			g_hKeyValues.JumpToKey(szCategory);
			
			if (g_hKeyValues.GetNum("is_category", 0) == 1)
			{
				AddClientStackCategory(iClient, szCategory);
				DisplayCategoriesMenu(iClient);
				return 0;
			}

			AddClientStackCategory(iClient, szCategory);
			DisplayCoinsMenu(iClient);
		}
	}

	return 0;
}

void DisplayCoinsMenu(int iClient, int iItem = 0)
{
	Menu hMenu = new Menu(MenuHandler_Coin);
	hMenu.ExitBackButton = true;
	hMenu.SetTitle("%t:\n ", "Title");

	g_hKeyValues.Rewind();

	g_hKeyValues.JumpToKey(g_szClientCategory[iClient]);

	if(g_hKeyValues.GotoFirstSubKey(false))
	{
		char szDisplay[64], szValue[16];
		do
		{
			g_hKeyValues.GetString(NULL_STRING, szDisplay, sizeof(szDisplay));
			g_hKeyValues.GetSectionName(szValue, sizeof(szValue));

			if (g_iClientCoin[iClient] && g_iClientCoin[iClient] == StringToInt(szValue))
			{
				Format(szDisplay, sizeof(szDisplay), "%s [V]", szDisplay);
				hMenu.AddItem(szValue, szDisplay, ITEMDRAW_DISABLED);
				continue;
			}

			hMenu.AddItem(szValue, szDisplay);
		}
		while (g_hKeyValues.GotoNextKey(false));
	}

	hMenu.DisplayAt(iClient, iItem, MENU_TIME_FOREVER);
}

public int MenuHandler_Coin(Menu hMenu, MenuAction action, int iClient, int iItem)
{
	switch(action)
	{
		case MenuAction_End:
		{
			hMenu.Close();
		}
		case MenuAction_Cancel:
		{
			if(iItem == MenuCancel_ExitBack)
			{
				RemoveLastClientStackCategory(iClient);
				DisplayCategoriesMenu(iClient);
			}
		}
		case MenuAction_Select:
		{
			char szValue[16];
			hMenu.GetItem(iItem, szValue, sizeof(szValue));

			g_iClientCoin[iClient] = StringToInt(szValue);
			SetClientCookie(iClient, g_hCookie, szValue);
			DisplayCoinsMenu(iClient, GetMenuSelectionPosition());
			VIP_PrintToChatClient(iClient, " \x04%t!", "Choose Coin");
		}
	}

	return 0;
}

void AddClientStackCategory(int iClient, const char[] szCategory)
{
	if (g_szClientCategory[iClient][0])
	{
		Format(g_szClientCategory[iClient], sizeof(g_szClientCategory[]), "%s/%s", g_szClientCategory[iClient], szCategory);
	}
	else
	{
		strcopy(g_szClientCategory[iClient], sizeof(g_szClientCategory[]), szCategory);
	}
}

void RemoveLastClientStackCategory(int iClient)
{
	if (!g_szClientCategory[iClient][0])
	{
		return;
	}
	
	int iPos = FindCharInString(g_szClientCategory[iClient], '/', true);
	if (iPos == -1)
	{
		iPos = 0;
	}
	
	g_szClientCategory[iClient][iPos] = 0;
}

public void VIP_OnVIPClientLoaded(int iClient)
{
	char szBuffer[16];
	GetClientCookie(iClient, g_hCookie, szBuffer, sizeof(szBuffer));
	g_iClientCoin[iClient] = StringToInt(szBuffer);
}

public void VIP_OnVIPClientRemoved(int iClient, const char[] sReason)
{
	if(g_iClientCoin[iClient])
	{
		g_iClientCoin[iClient] = 0;
	}
}

public void OnClientPutInServer(int iClient)
{
	g_iClientCoin[iClient] = 0;
}

public void OnClientDisconnect(int iClient) 
{ 
    g_iClientCoin[iClient] = 0;
}  

public bool OnItemSelect(int iClient, const char[] sFeatureName)
{
	g_szClientCategory[iClient][0] = 0;
	DisplayCategoriesMenu(iClient);

	return false;
}

public void Hook_OnThinkPost(int iEntity)
{
	for (int i = 1; i <= MaxClients; ++i)
	{
		if(g_iClientCoin[i]) SetEntData(iEntity, m_nActiveCoinRank + i*4, g_iClientCoin[i], 4, true);
	}
}